/*
       WS2812B.   :
    (, 30).   60 
   ,  90
    (  )
     (  )

*/


.def temp = r16		; 
.def counter = r17	; 
.def curFn = r18	;     
.def curEf = r19	;7..4 -  , 3..0 -  

.def R = r20	;  
.def G = r21	;
.def B = r22	; 
.def F = r23	;    

;  ,  . ,       :)
.equ G_HIGH = 1
.equ R_DOWN = 2
.equ B_HIGH = 3
.equ G_DOWN = 4
.equ R_HIGH = 5
.equ B_DOWN = 6
.equ MAX_FLAG = 7

.equ LED_COUNT = 17						;-  (,    )
.equ BUFFER_SIZE = LED_COUNT*12+1		;  
.equ XTAL = 8000000						;  (  ,     )
.equ DIV = 256							;  
.equ TPS = XTAL / DIV					;    
.equ END = 0xFE							; 

.equ PORTNUM = 7
.equ T = 6	;  T  SREG

.macro Write
	ldi temp,@0
	st Y+,temp
.endm

.dseg
BytesBuffer:	.byte BUFFER_SIZE
ColorsTable:	.byte LED_COUNT*3+1			;3 -  (R,G,B), 1    
MaxFrame:		.byte 1						; ,   ,   
CurEffectAddr:	.byte 2						;low - +0   high - +1

.equ CEA_H = CurEffectAddr + 1
.equ CEA_L = CurEffectAddr + 0

.cseg
.org 0 
rjmp RESET 
reti; rjmp EXT_INT0 ; IRQ0 Handler
reti; rjmp EXT_INT1 ; IRQ1 Handler
reti;rjmp TIM2_COMP ; Timer2 Compare Handler
reti; rjmp TIM2_OVF ; Timer2 Overflow Handler
reti; rjmp TIM1_CAPT ; Timer1 Capture Handler
rjmp TIM1_COMPA ; Timer1 CompareA Handler
reti; rjmp TIM1_COMPB ; Timer1 CompareB Handler
reti; rjmp TIM1_OVF ; Timer1 Overflow Handler
reti; rjmp TIM0_OVF ; Timer0 Overflow Handler
reti; rjmp SPI_STC ; SPI Transfer Complete Handler
reti; rjmp USART_RXC ; USART RX Complete Handler
reti; rjmp USART_UDRE ; UDR Empty Handler
reti; rjmp USART_TXC ; USART TX Complete Handler
reti; rjmp ADC_Handler ; ADC Conversion Complete Handler
reti; rjmp EE_RDY ; EEPROM Ready Handler
reti; rjmp ANA_COMP ; Analog Comparator Handler
reti; rjmp TWSI ; Two-wire Serial Interface
reti; rjmp SPM_RDY ; Store Program Memory Ready
RESET:
ldi temp,high(RamEnd)
out SPH,temp
ldi temp,low(RamEnd)
out SPL,temp

ldi temp,(1<<PORTNUM);
out DDRD,temp
out PortD,temp

ldi R,15
clr G
clr B
ldi F,1

;ldi curEf,0x[      HEX-]0		
clr curFn			; 0 

clr temp
out TCNT1H,temp
out TCNT1L,temp
ldi temp,(1<<CS12)
out TCCR1B,temp
ldi temp,(1<<OCIE1A)
out TIMSK,temp

cbi PortD,PORTNUM
rcall Delay

ldi ZH,high(EffectsTable*2)
ldi ZL,low(EffectsTable*2)
rcall LoadEffectAddress
sts CEA_H,ZH
sts CEA_L,ZL

lpm temp,Z+
out OCR1AH,temp
lpm temp,Z+
out OCR1AL,temp
lpm temp,Z+
sts MaxFrame,temp
lpm temp,Z+
bst temp,0			;   temp   T
ldi YH,high(ColorsTable)
ldi YL,low(ColorsTable)
ldi counter,LED_COUNT
brtc WithoutT
rcall FillColorsTableT
rjmp Cont01
WithoutT:
rcall FillColorsTable
Cont01:
 
push ZL
push ZH
ldi ZH,high(ColorsTable)	;!!!
ldi ZL,low(ColorsTable)		;!!!
ldi YH,high(BytesBuffer)
ldi YL,low(BytesBuffer)
rcall ReadColorTable
pop ZH
pop ZL

Write END	;end marker
ldi YH,high(BytesBuffer)
ldi YL,low(BytesBuffer)
sei

LoadData:
cli				;    .  ,      ,     -.
LoadData2:
ld temp,Y+
cpi temp,END
breq FromBegin
Out1:
out PortD,temp
lsl temp
nop
out PortD,temp
lsl temp
nop
out PortD,temp
lsl temp
nop
out PortD,temp
lsl temp
nop
out PortD,temp
lsl temp
nop
out PortD,temp
lsl temp
nop
cbi PortD,PORTNUM
rjmp PC+1		; 2 ,   2 ,    2*nop,    ,
rjmp PC+1		;  4 
rjmp PC+1
rjmp PC+1
rjmp PC+1
rjmp PC+1
rjmp LoadData2

FromBegin:
sei
cbi PortD,PORTNUM
Loop: 

rjmp Loop

TIM1_CompA:
	clr temp
	out TCNT1H,temp
	out TCNT1L,temp

	lpm temp,Z
	cpi temp,END
	breq ReloadColorTableFromTimer

	ContinueTimer:

	ldi counter,LED_COUNT
	ldi YH,high(ColorsTable)
	ldi YL,low(ColorsTable)
	brtc DontNeedHandleFlashes
	rcall ChangeInt	; -    R,G,B
	rcall FillColorsTableT
	rjmp Cont02
	;ZH:ZL  
	DontNeedHandleFlashes:
	rcall FillColorsTable

	Cont02:
	push ZL
	push ZH
	ldi ZH,high(ColorsTable)	;!!!
	ldi ZL,low(ColorsTable)		;!!!
	ldi YH,high(BytesBuffer)
	ldi YL,low(BytesBuffer)
	rcall ReadColorTable
	pop ZH
	pop ZL
	Write END
	ldi YH,high(BytesBuffer)
	ldi YL,low(BytesBuffer)

	inc curFn
	lds temp,MaxFrame
	cp temp,curFn
	breq LoadNewEffect

	pop temp
	pop temp
	sei
	rjmp LoadData

;     ,       4 
ReloadColorTableFromTimer:
	lds ZH,CEA_H
	lds ZL,CEA_L
	lpm temp,Z+
	out OCR1AH,temp
	lpm temp,Z+
	out OCR1AL,temp
	lpm temp,Z+
	sts MaxFrame,temp
	lpm temp,Z+
	bst temp,0
rjmp ContinueTimer

LoadNewEffect:
	ldi ZH,high(EffectsTable*2)
	ldi ZL,low(EffectsTable*2)
	rcall LoadEffectAddress
	sts CEA_H,ZH
	sts CEA_L,ZL
	clr curFn
	lpm temp,Z+
	out OCR1AH,temp
	lpm temp,Z+
	out OCR1AL,temp
	lpm temp,Z+
	sts MaxFrame,temp
	lpm temp,Z+
	bst temp,0
	ldi YH,high(ColorsTable)
	ldi YL,low(ColorsTable)
	ldi counter,LED_COUNT
	brtc WithoutT2
	rcall FillColorsTableT
	rjmp Cont03
	WithoutT2:
	rcall FillColorsTable
	Cont03:

	push ZL
	push ZH
	ldi ZH,high(ColorsTable)	;!!!
	ldi ZL,low(ColorsTable)		;!!!
	ldi YH,high(BytesBuffer)
	ldi YL,low(BytesBuffer)
	rcall ReadColorTable
	pop ZH
	pop ZL

	Write END	;end marker
	ldi YH,high(BytesBuffer)
	ldi YL,low(BytesBuffer)
	pop temp
	pop temp
	sei
	rjmp LoadData

Delay:
	clr temp
	dec temp
	rjmp PC+1
	rjmp PC+1
	brne PC-3
ret

;: ZH:ZL -      , YH:YL -   
;: ZH:ZL(?), YH:YL -   
ReadColorTable:
	adiw Z,1
	ld R0,Z
	rcall ColorToBytes
	sbiw Z,1
	ld R0,Z
	rcall ColorToBytes
	adiw Z,2
	ld R0,Z
	rcall ColorToBytes

	adiw Z,1
	ld temp,Z
	cpi temp,END
	brne ReadColorTable
ret


;  - R0 -   , YH:YL -    .
;  - YH:YL+4(4    )
ColorToBytes:
	ldi temp,0x88
	sbrc R0,7
	subi temp,-(1<<6)
	sbrc R0,6
	subi temp,-(1<<2)
	st Y+,temp

	ldi temp,0x88
	sbrc R0,5
	subi temp,-(1<<6)
	sbrc R0,4
	subi temp,-(1<<2)
	st Y+,temp

	ldi temp,0x88
	sbrc R0,3
	subi temp,-(1<<6)
	sbrc R0,2
	subi temp,-(1<<2)
	st Y+,temp

	ldi temp,0x88
	sbrc R0,1
	subi temp,-(1<<6)
	sbrc R0,0
	subi temp,-(1<<2)
	st Y+,temp	
ret


;    ,    
;   
;: YH:YL -  , ZH:ZL -  
;: YH:YL -    , ZH:ZL   counter*3 
FillColorsTableT:
	push counter
	AfterSavingFCT:
	lpm temp,Z+
	mul temp,R
	st Y+,R0

	lpm temp,Z+
	mul temp,G
	st Y+,R0

	lpm temp,Z+
	mul temp,B
	st Y+,R0

	dec counter
	cpi counter,0
	brne AfterSavingFCT

	ldi temp,END
	st Y+,temp
	pop counter
ret

;    ,   . - (15)
;   
;: YH:YL -  , ZH:ZL -  
;: YH:YL -    , ZH:ZL   counter*3 
FillColorsTable:
	push counter
	ldi temp,15
	AfterSavingFCT2:
	lpm R0,Z+
	mul R0,temp
	st Y+,R0

	lpm R0,Z+
	mul R0,temp
	st Y+,R0

	lpm R0,Z+
	mul R0,temp
	st Y+,R0

	dec counter
	cpi counter,0
	brne AfterSavingFCT2

	ldi temp,END
	st Y+,temp
	pop counter
ret

.equ MAX_INT = 16
;      ,        
ChangeInt:
cpi F,G_HIGH
breq hgh
cpi F,R_DOWN
breq hrd
cpi F,B_HIGH
breq hbh
cpi F,G_DOWN
breq hgd
cpi F,R_HIGH
breq hrh
cpi F,B_DOWN
breq hbd
ret
ChangeIntEnd:
inc F
cpi F,MAX_FLAG
breq ResetF
ret
ResetF:
ldi F,G_HIGH
ret
hgh:
inc G
cpi G,MAX_INT-1
breq ChangeIntEnd
ret
hrd:
dec R
cpi R,0
breq ChangeIntEnd
ret
hbh:
inc B
cpi B,MAX_INT-1
breq ChangeIntEnd
ret
hgd:
dec G
cpi G,0
breq ChangeIntEnd
ret
hrh:
inc R
cpi R,MAX_INT-1
breq ChangeIntEnd
ret
hbd:
dec B
cpi B,0
breq ChangeIntEnd
ret

;  
;: ZH:ZL -  , curEf -       
;: ZH:ZL -   , curEf -        
LoadEffectAddress:
mov temp,curEf
andi temp,0x0F
lsl temp
add ZL,temp
clr temp
adc ZH,temp
lpm temp,Z+
lpm ZH,Z
mov ZL,temp
clc
rol ZL
rol ZH
inc curEf
mov temp,curEf
swap temp
cp temp,curEf
breq ResetCurEf
ret
ResetCurEf:
andi curEf,0xF0
ret

;    .  :
;EffectName:
;.db high(TPS/[    ]), low(TPS/[]), [   ]*[ -  .] (  255), 0/1[ "":  ,  1]
;.db [   : R,G,B], END


EffectsTable:				;       
;.dw Effect01, ... , EffecNN

; : OCR1AH,OCR1AL,   , * ,  ( 3: R,G,B)